diff -uNrd ircd-ratbox-1.3-1/modules/m_svsnick.c BgChat-Ircd/modules/m_svsnick.c
--- ircd-ratbox-1.3-1/modules/m_svsnick.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_svsnick.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,211 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_svsnick.c: Sets a users nick to random one when the nickname is
+ *               registered and user did not identify within 30 seconds.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svsnick.c,v 1.109 2004/02/10 14:46:00 HaKer4o Exp $
+ */
+
+#include "stdinc.h"
+#include "handlers.h"
+#include "client.h"
+#include "hash.h"
+#include "fdlist.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_conf.h"
+#include "s_stats.h"
+#include "s_user.h"
+#include "hash.h"
+#include "whowas.h"
+#include "s_serv.h"
+#include "send.h"
+#include "channel.h"
+#include "s_log.h"
+#include "resv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "common.h"
+#include "packet.h"
+
+
+static void m_svsnick(struct Client *, struct Client *, int, char **);
+
+static int check_clean_nick(struct Client *, struct Client *, char *, char *, char *);
+static int clean_nick_name(char *);
+
+struct Message svsnick_msgtab = {
+	"SVSNICK", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_ignore, m_svsnick, m_svsnick, m_svsnick}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svsnick_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svsnick_msgtab);
+}
+
+const char *_version = "$Revision: 1.1 $";
+#endif
+
+/*
+ * m_svsnick()
+ *
+ *     parv[0] = sender prefix
+ *     parv[1] = target nickname
+ *     parv[2] = new nickname
+ */
+static void
+m_svsnick(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	char nick[NICKLEN];
+	struct Client *target_p;
+	struct Client *dest_p;
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+	    return;
+	}
+	
+	if(parc < 3 || BadPtr(parv[2]))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "No nickname given via SVSNICK from %s for %s", parv[0], parv[1]);
+		return;
+	}
+
+	/* terminate nick to NICKLEN */
+	strlcpy(nick, parv[2], sizeof(nick));
+
+	/* check the nickname is ok */
+	if(!clean_nick_name(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Bogus nickname via SVSNICK from %s for %s : %s", parv[0], parv[1], parv[2]);
+      return;
+	}
+
+	if(find_nick_resv(nick))
+	{
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Unavailable nickname via SVSNICK from %s for %s : %s", parv[0], parv[1], parv[2]);
+		return;
+	}
+	
+	if(!(dest_p = find_client(parv[1]))) {
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "Nickname (%s) not found via SVSNICK",parv[1]);
+		return;
+	}
+	if (MyClient(dest_p)) {
+    	    ilog(L_ALL,"SVSNICK LOCAL %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SVSNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+
+	    change_local_nick(&me, dest_p, nick);
+	    }
+	else {
+    	    ilog(L_ALL,"SVSNICK REMOTE %s %s",parv[1],parv[2]);	
+  	  sendto_wallops_flags(UMODE_WALLOP, &me,
+	     "SVSNICK [ %s ] -> [ %s ] by %s",parv[1],parv[2],parv[0]);
+	    sendto_one(dest_p->servptr,":%s SVSNICK %s %s", me.name,
+	                                      parv[1], nick);
+	}
+}
+/* 
+ * check_clean_nick()
+ * 
+ * input	- pointer to source
+ *		- nickname
+ *		- truncated nickname
+ *		- origin of client
+ * output	- none
+ * side effects - if nickname is erroneous, or a different length to
+ *                truncated nickname, return 1
+ */
+static int
+check_clean_nick(struct Client *client_p, struct Client *source_p,
+		 char *nick, char *newnick, char *server)
+{
+	/* the old code did some wacky stuff here, if the nick is invalid, kill it
+	 * and dont bother messing at all
+	 */
+
+	/*
+	 * Zero length nicks are bad too..this shouldn't happen but..
+	 */
+
+	if(!clean_nick_name(nick) || strcmp(nick, newnick) || nick[0] == '\0')
+	{
+		ServerStats->is_kill++;
+		sendto_realops_flags(UMODE_DEBUG, L_ALL,
+				     "Bad Nick: %s From: %s(via %s)", nick, server, client_p->name);
+
+		sendto_one(client_p, ":%s KILL %s :%s (Bad Nickname)", me.name, newnick, me.name);
+
+		/* bad nick change */
+		if(source_p != client_p)
+		{
+			kill_client_serv_butone(client_p, source_p, "%s (Bad Nickname)", me.name);
+			source_p->flags |= FLAGS_KILLED;
+			exit_client(client_p, source_p, &me, "Bad Nickname");
+		}
+
+		return 1;
+	}
+
+	return 0;
+}
+
+/* clean_nick_name()
+ *
+ * input	- nickname
+ * output	- none
+ * side effects - walks through the nickname, returning 0 if erroneous
+ */
+static int
+clean_nick_name(char *nick)
+{
+	assert(nick);
+	if(nick == NULL)
+		return 0;
+
+	/* nicks cant start with a digit or -, and must have a length */
+	if(*nick == '-' || IsDigit(*nick) || !*nick)
+		return 0;
+
+	for (; *nick; nick++)
+	{
+		if(!IsNickChar(*nick))
+			return 0;
+	}
+
+	return 1;
+}
+
diff -uNrd ircd-ratbox-1.3-1/modules/m_svspart.c BgChat-Ircd/modules/m_svspart.c
--- ircd-ratbox-1.3-1/modules/m_svspart.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_svspart.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,203 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_part.c: Parts a user from a channel.
+ *
+ *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
+ *  Copyright (C) 1996-2002 Hybrid Development Team
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_svspart.c,v 1.80.3.3 2004/02/07 15:44:42 MaskBg Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "common.h"
+#include "hash.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_serv.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+#include "s_conf.h"
+#include "packet.h"
+
+static void m_svspart(struct Client *, struct Client *, int, char **);
+void check_spambot_warning(struct Client *source_p, const char *name);
+
+struct Message svspart_msgtab = {
+	"SVSPART", 0, 0, 3, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_svspart, m_svspart, m_svspart}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&svspart_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&svspart_msgtab);
+}
+const char *_version = "$Revision: 1.1.8 $";
+#endif
+
+static void part_one_client(struct Client *client_p,
+			    struct Client *source_p, char *name, char *reason);
+
+
+/*
+** m_svspart
+**      parv[0] = sender prefix
+**      parv[1] = channel
+**      parv[2] = reason
+*/
+static void
+m_svspart(struct Client *client_p, struct Client *source_p, int parc, char *parv[])
+{
+	char *p, *name;
+	char reason[TOPICLEN + 1];
+	struct Client *dest_p = NULL;
+
+	if (!IsServer(source_p) && !IsAdmin(source_p)) {
+		sendto_one(source_p, form_str(ERR_RESTRICTED), me.name, source_p->name);
+		return;
+	
+	}
+
+	if(EmptyString(parv[1]) || EmptyString(parv[2]))
+	{
+		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "SVSPART");
+		return;
+	}
+	if(!IsServer(source_p) && !IsAdmin(source_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN,
+				     "DENIED ACCESS to SVSPART for %s !", source_p->name);
+		ilog(L_ALL, "DENIED ACCESS to SVSPART for %s !", source_p->name);
+		return;
+	}
+	if(!(dest_p = find_person(parv[1])))
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name, parv[0], parv[1]);
+		return;
+	}
+
+	if(!MyClient(dest_p))
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Forwarding SVSPART from %s for %s/%s",
+				     parv[0], parv[1], parv[2]);
+		ilog(L_ALL, "Forwarding SVSPART from %s for %s/%s", parv[0], parv[1], parv[2]);
+		sendto_one(dest_p->servptr, ":%s SVSPART %s %s %s", parv[0],
+			   parv[1], parv[2], (parv[3]) ? parv[3] : NULL);
+		return;
+	}
+	else
+	{
+		sendto_realops_flags(UMODE_ALL, L_ADMIN, "Received SVSPART from %s for %s/%s",
+				     parv[0], parv[1], parv[2]);
+		ilog(L_ALL, "Received SVSPART from %s for %s/%s", parv[0], parv[1], parv[2]);
+	}
+
+	reason[0] = '\0';
+
+	if(parc > 3)
+		strlcpy(reason, parv[3], sizeof(reason));
+
+	name = strtoken(&p, parv[2], ",");
+
+	/* Finish the flood grace period... */
+	if(MyClient(dest_p) && !IsFloodDone(dest_p))
+		flood_endgrace(dest_p);
+
+	while (name)
+	{
+		part_one_client(client_p, dest_p, name, reason);
+		name = strtoken(&p, (char *) NULL, ",");
+	}
+	return;
+}
+
+/*
+ * part_one_client
+ *
+ * inputs	- pointer to server
+ * 		- pointer to source client to remove
+ *		- char pointer of name of channel to remove from
+ * output	- none
+ * side effects	- remove ONE client given the channel name 
+ */
+static void
+part_one_client(struct Client *client_p, struct Client *source_p, char *name, char *reason)
+{
+	struct Channel *chptr;
+	struct membership *msptr;
+
+	if((chptr = hash_find_channel(name)) == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL), me.name, source_p->name, name);
+		return;
+	}
+
+	msptr = find_channel_membership(chptr, source_p);
+	if(msptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOTONCHANNEL), me.name, source_p->name, name);
+		return;
+	}
+	if(MyConnect(source_p) && !IsOper(source_p) && !IsExemptSpambot(source_p))
+		check_spambot_warning(source_p, NULL);
+
+	/*
+	 *  Remove user from the old channel (if any)
+	 *  only allow /part reasons in -m chans
+	 */
+	if(reason[0] && (is_chanop(msptr) || !MyConnect(source_p) ||
+			 ((can_send(chptr, source_p, msptr) > 0 &&
+			   (source_p->firsttime + ConfigFileEntry.anti_spam_exit_message_time)
+			   < CurrentTime))))
+	{
+		sendto_server(&me /* client_p */, chptr, NOCAPS, NOCAPS,
+			      ":%s PART %s :%s", source_p->name, chptr->chname, reason);
+
+		sendto_channel_local(ALL_MEMBERS,
+				     chptr, ":%s!%s@%s PART %s :%s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname, reason);
+	}
+	else
+	{
+		sendto_server(&me /* client_p */, chptr, NOCAPS, NOCAPS,
+			      ":%s PART %s", source_p->name, chptr->chname);
+
+		sendto_channel_local(ALL_MEMBERS,
+				     chptr, ":%s!%s@%s PART %s",
+				     source_p->name,
+				     source_p->username, source_p->host, chptr->chname);
+	}
+	del_nokick_chan(source_p, name);
+	remove_user_from_channel(msptr);
+}
diff -uNrd ircd-ratbox-1.3-1/modules/m_to.c BgChat-Ircd/modules/m_to.c
--- ircd-ratbox-1.3-1/modules/m_to.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_to.c	Mon Mar 29 07:17:54 2004
@@ -0,0 +1,177 @@
+/*
+ *   IRC - Internet Relay Chat, contrib/m_clearchan.c
+ *   Copyright (C) 2002 Hybrid Development Team
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   $Id: m_to.c,v 1.45.2.3 2004/02/09 02:51:50 HaKer4o Exp $
+ */
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "channel.h"
+#include "channel_mode.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_log.h"
+#include "s_serv.h"
+#include "send.h"
+#include "whowas.h"
+#include "irc_string.h"
+#include "sprintf_irc.h"
+#include "hash.h"
+#include "msg.h"
+#include "parse.h"
+#include "modules.h"
+
+static void mo_clearchan(struct Client *client_p, struct Client *source_p,
+                         int parc, char *parv[]);
+
+struct Message clearchan_msgtab = {
+	"TO", 0, 0, 2, 0, MFLG_SLOW, 0,
+	{m_unregistered, m_not_oper, m_ignore, mo_clearchan}
+};
+
+#ifndef STATIC_MODULES
+void
+_modinit(void)
+{
+	mod_add_cmd(&clearchan_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+	mod_del_cmd(&clearchan_msgtab);
+}
+
+const char *_version = "$Revision: 1.45.2.3 $";
+#endif
+
+/*
+** mo_clearchan
+**      parv[0] = sender prefix
+**      parv[1] = channel
+*/
+static void mo_clearchan(struct Client *client_p, struct Client *source_p,
+                        int parc, char *parv[])
+{
+	struct Channel *chptr;
+	struct membership *msptr;
+	struct Client *target_p;
+	dlink_node *ptr;
+	dlink_node *next_ptr;
+
+	/* admins only */
+	if (!IsOperAdmin(source_p))
+	{
+		sendto_one(source_p, ":%s NOTICE %s :You have no A flag", 
+			   me.name, parv[0]);
+		return;
+	}
+
+	chptr = hash_find_channel(parv[1]);
+
+	if(chptr == NULL)
+	{
+		sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+			   me.name, parv[0], parv[1]);
+		return;
+	}
+
+	if(IsMember(source_p, chptr))
+	{
+		sendto_one(source_p, ":%s NOTICE %s :*** Please part %s before using TakeOwar",
+			   me.name, source_p->name, parv[1]);
+		return;
+	}
+
+	/* quickly make everyone a peon.. */
+	DLINK_FOREACH(ptr, chptr->members.head)
+	{
+		msptr = ptr->data;
+		msptr->flags &= ~CHFL_CHANOP|CHFL_VOICE;
+	}
+
+	sendto_wallops_flags(UMODE_WALLOP, &me, 
+			     "TakeOwar Forr [%s] by %s!%s@%s",
+			     parv[1], source_p->name, source_p->username, source_p->host);
+	ilog(L_NOTICE, "TakeOwar For [%s] by %s!%s@%s",
+	     parv[1], source_p->name, source_p->username, source_p->host);
+
+	if(*chptr->chname != '&')
+	{
+		sendto_server(NULL, NULL, NOCAPS, NOCAPS, 
+			      ":%s WALLOPS :TakeOwar For [%s] by %s!%s@%s",
+			      me.name, parv[1], source_p->name, source_p->username,
+			      source_p->host);
+
+		/* SJOIN the user to give them ops, and lock the channel */
+		sendto_server(client_p, chptr, NOCAPS, NOCAPS,
+				":%s SJOIN %lu %s +ntsi :@%s",
+				me.name, (unsigned long) (chptr->channelts - 1),
+				chptr->chname, source_p->name);
+	}
+
+	sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN %s",
+			     source_p->name, source_p->username,
+			     source_p->host, chptr->chname);
+	sendto_channel_local(ALL_MEMBERS, chptr, ":%s MODE %s +o %s",
+			     me.name, chptr->chname, source_p->name);
+
+	add_user_to_channel(chptr, source_p, CHFL_CHANOP);
+
+	/* Take the TS down by 1, so we don't see the channel taken over
+	 * again. */
+	if (chptr->channelts)
+		chptr->channelts--;
+
+	chptr->mode.mode = MODE_SECRET|MODE_TOPICLIMIT|MODE_INVITEONLY|MODE_NOPRIVMSGS;
+	free_topic(chptr);
+	chptr->mode.key[0] = '\0';
+
+	DLINK_FOREACH_SAFE(ptr, next_ptr, chptr->members.head)
+	{
+		msptr = ptr->data;
+		target_p = msptr->client_p;
+
+		/* skip the person we just added.. */
+		if(is_chanop(msptr))
+			continue;
+
+		sendto_channel_local(ALL_MEMBERS, chptr,
+				     ":%s KICK %s %s :TaKeOwAr for Stuped Chan",
+				     source_p->name, chptr->chname, 
+				     target_p->name);
+
+		if(*chptr->chname != '&')
+			sendto_server(NULL, chptr, NOCAPS, NOCAPS, 
+				      ":%s KICK %s %s :TaKeOwAr for Stuped Chan", 
+				      source_p->name, chptr->chname, 
+				      target_p->name);
+
+		remove_user_from_channel(msptr);
+	}
+
+	/* Join the user themselves to the channel down here, so they dont see a nicklist 
+	 * or people being kicked */
+	sendto_one(source_p, ":%s!%s@%s JOIN %s",
+		   source_p->name, source_p->username,
+		   source_p->host, chptr->chname);
+
+	channel_member_names(chptr, source_p, 1);
+}
+
diff -uNrd ircd-ratbox-1.3-1/modules/m_user.c BgChat-Ircd/modules/m_user.c
--- ircd-ratbox-1.3-1/modules/m_user.c	Thu Jun 26 10:02:15 2003
+++ BgChat-Ircd/modules/m_user.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_user.c: Sends username information.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
diff -uNrd ircd-ratbox-1.3-1/modules/m_users.c BgChat-Ircd/modules/m_users.c
--- ircd-ratbox-1.3-1/modules/m_users.c	Thu Jun 26 10:02:15 2003
+++ BgChat-Ircd/modules/m_users.c	Mon Mar 29 07:17:53 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_users.c: Gives some basic user statistics.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_users.c,v 1.36.2.1 2003/06/26 14:02:15 androsyn Exp $
+ *  $Id: m_users.c,v 1.36.2.1 2004/02/03 14:02:15 MaskBg Exp $
  */
 
 #include "stdinc.h"
@@ -80,6 +79,16 @@
 
 	sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 		   Count.total, Count.max_tot);
+
+	sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+		   CurrentIdentUsers, MaxIdentUsers);
+
+	sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+		   CurrentOSidUsers, MaxOSidUsers);
+
+	sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+		   CurrentGlinerUsers, MaxGlinerUsers);
+
 }
 
 /*
@@ -101,5 +110,15 @@
 
 		sendto_one(source_p, form_str(RPL_GLOBALUSERS), me.name, parv[0],
 			   Count.total, Count.max_tot);
+
+		sendto_one(source_p, form_str(RPL_IDENTUSERS), me.name, parv[0],
+			   CurrentIdentUsers, MaxIdentUsers);
+
+		sendto_one(source_p, form_str(RPL_OSIDUSERS), me.name, parv[0],
+			   CurrentOSidUsers, MaxOSidUsers);
+
+		sendto_one(source_p, form_str(RPL_GLIDUSERS), me.name, source_p->name,
+			   CurrentGlinerUsers, MaxGlinerUsers);
+
 	}
 }
diff -uNrd ircd-ratbox-1.3-1/modules/m_wallops.c BgChat-Ircd/modules/m_wallops.c
--- ircd-ratbox-1.3-1/modules/m_wallops.c	Fri Nov 28 10:54:58 2003
+++ BgChat-Ircd/modules/m_wallops.c	Fri Apr  9 05:18:05 2004
@@ -1,27 +1,9 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrd: an advanced Internet Relay Chat Daemon(ircd).
  *  m_wallops.c: Sends a message to all operators.
- *
- *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
- *  Copyright (C) 1996-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; either version 2 of the License, or
- *  (at your option) any later version.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
- *  USA
- *
- *  $Id: m_wallops.c,v 1.45.2.4 2003/11/28 15:54:58 leeh Exp $
+ *  Tenks For Stx - Devel BgChat.Com
+ *  BgChat Devel [HaKer4o]
+ *  $Id: m_wallops.c,v 1.45.2.4 2004/02/28 19:34:18 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -71,15 +53,21 @@
 	char *message;
 
 	message = parv[1];
-
+       /* patched no wallops from locops by stx - haker4o */
+        if(!IsOperOperwall(source_p))
+        {
+                sendto_one(source_p, ":%s NOTICE %s :You need operwall = yes;",
+                           me.name, source_p->name);
+                return;
+        }
 	if(EmptyString(message))
 	{
 		sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS), me.name, parv[0], "WALLOPS");
 		return;
 	}
 
-	sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
-	sendto_server(NULL, NULL, NOCAPS, NOCAPS, ":%s OPERWALL :%s", parv[0], message);
+	sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
+	sendto_server(NULL, NULL, NOCAPS, NOCAPS, ":%s WALLOPS :%s", parv[0], message);
 }
 
 /*
@@ -101,7 +89,7 @@
 	}
 
 	if(IsClient(source_p))
-		sendto_wallops_flags(UMODE_OPERWALL, source_p, "OPERWALL - %s", message);
+		sendto_wallops_flags(UMODE_OPERWALL, source_p, "WALLOPS - %s", message);
 	else
 		sendto_wallops_flags(UMODE_WALLOP, source_p, "%s", message);
 
diff -uNrd ircd-ratbox-1.3-1/modules/m_whois.c BgChat-Ircd/modules/m_whois.c
--- ircd-ratbox-1.3-1/modules/m_whois.c	Fri Nov 28 10:14:51 2003
+++ BgChat-Ircd/modules/m_whois.c	Mon Mar 29 07:17:54 2004
@@ -1,5 +1,5 @@
 /*
- *  ircd-ratbox: an advanced Internet Relay Chat Daemon(ircd).
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
  *  m_whois.c: Shows who a user is.
  *
  *  Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
@@ -282,6 +282,42 @@
 		   target_p->username, target_p->host, target_p->info);
 	server_name = (char *) target_p->user->server;
 
+	if (IsNSId(target_p)) {
+         sendto_one(source_p, form_str(RPL_WHOISSVSHINT), me.name,
+               source_p->name, target_p->name);
+	}
+
+        if (IsOSId(target_p)) {
+           sendto_one(source_p, form_str(RPL_OS_ID),
+                      me.name, source_p->name, target_p->name);
+	}
+
+       if (IsGLId(target_p)) {
+                sendto_one(source_p, form_str(RPL_NK_ID),
+            me.name, source_p->name, target_p->name);
+        }
+
+        if (HasSilence(target_p)) {
+	   sendto_one(source_p, form_str(RPL_SILENCE),
+    		      me.name, source_p->name, target_p->name);
+	}
+	
+	if (target_p->umodes & UMODE_CALLERID) {
+ 		sendto_one(source_p, form_str(RPL_INGMODE),
+ 		     me.name, source_p->name, target_p->name);
+	}
+
+	 if (s_check(target_p->name)) {
+            if (strcasecmp(target_p->name,"seenserv") != 0) {
+                sendto_one(source_p, form_str(RPL_WHOISSVSHINT), me.name,
+                       source_p->name, target_p->name);
+            }
+           ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name);
+		sendto_one(source_p, "%s%s", buf, "The Channel list is hidden");
+
+	} else {
+
+
 	cur_len = mlen = ircsprintf(buf, form_str(RPL_WHOISCHANNELS), me.name, source_p->name, target_p->name);
 	t = buf + mlen;
 
@@ -312,6 +348,9 @@
 	if(cur_len > mlen)
 		sendto_one(source_p, "%s", buf);
 
+    }
+
+
 	if((IsOper(source_p) || !ConfigServerHide.hide_servers) || target_p == source_p)
 		sendto_one(source_p, form_str(RPL_WHOISSERVER),
 			   me.name, source_p->name, target_p->name, server_name,
@@ -325,14 +364,14 @@
 		sendto_one(source_p, form_str(RPL_AWAY), me.name,
 			   source_p->name, target_p->name, target_p->user->away);
 
-	if(IsOper(target_p))
-	{
-			sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
-				   me.name, source_p->name, target_p->name,
-				   IsAdmin(target_p) ? GlobalSetOptions.adminstring :
-				   GlobalSetOptions.operstring);
-	}
-
+        if(IsOper(target_p))
+        {
+                        sendto_one(source_p, form_str(RPL_WHOISOPERATOR),
+                                   me.name, source_p->name, target_p->name,
+                                   IsAdmin(target_p) ? GlobalSetOptions.adminstring :
+                                   GlobalSetOptions.operstring);
+        }
+	
 	if(MyClient(target_p))
 	{
 	  /* send idle if its global, source == target, or source and target
diff -uNrd ircd-ratbox-1.3-1/modules/m_whoisme.c BgChat-Ircd/modules/m_whoisme.c
--- ircd-ratbox-1.3-1/modules/m_whoisme.c	Wed Dec 31 19:00:00 1969
+++ BgChat-Ircd/modules/m_whoisme.c	Mon Mar 29 07:17:53 2004
@@ -0,0 +1,63 @@
+/*
+ *  ircd-ratbox: A slightly useful ircd.
+ *  spy_whois_notice.c: Sends a notice when someone uses WHOIS.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: spy_whois_notice.c,v 1.15.4.1 2003/06/26 14:01:05 androsyn Exp $
+ */
+#include "stdinc.h"
+#include "modules.h"
+#include "hook.h"
+#include "client.h"
+#include "ircd.h"
+#include "send.h"
+
+int
+show_notice(struct hook_mfunc_data *);
+
+void
+_modinit(void)
+{
+  hook_add_hook("doing_whois_local", (hookfn *)show_notice);
+}
+
+void
+_moddeinit(void)
+{
+  hook_del_hook("doing_whois_local", (hookfn *)show_notice);
+}
+
+const char *_version = "$Revision: 1.15.4.1 $";
+
+/* show a whois notice
+   source_p does a /whois on client_p */
+int
+show_notice(struct hook_mfunc_data *data)
+{
+  if (MyConnect(data->source_p) && MyConnect(data->client_p) &&
+      IsOper(data->client_p) && (data->client_p != data->source_p) 
+      && data->client_p->umodes & UMODE_SPY) 
+    {
+      sendto_one(data->client_p, ":%s NOTICE %s :*** Notice -- %s (%s@%s) is doing a whois on you [%s]",
+                 me.name, data->client_p->name, data->source_p->name, data->source_p->username,
+                 data->source_p->host, data->source_p->user->server);
+    }
+
+  return 0;
+}
diff -uNrd ircd-ratbox-1.3-1/src/adns.c BgChat-Ircd/src/adns.c
--- ircd-ratbox-1.3-1/src/adns.c	Mon Oct  6 16:49:55 2003
+++ BgChat-Ircd/src/adns.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  adns.c: Interfaces to the adns DNS library.
  *
  *  Copyright (C) 2001-2002 Aaron Sethman <androsyn@ratbox.org> 
  *  Copyright (C) 2001-2002 Hybrid Development Team
- *  Copyright (C) 2002 ircd-ratbox development team
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: adns.c,v 7.60.2.2 2003/10/06 20:49:55 androsyn Exp $
+ *  $Id: adns.c,v 7.60.2.2 2004/02/09 21:18:55 HaKer4o Exp $
  */
 
 #include "stdinc.h"
diff -uNrd ircd-ratbox-1.3-1/src/balloc.c BgChat-Ircd/src/balloc.c
--- ircd-ratbox-1.3-1/src/balloc.c	Sat Jun 28 04:49:41 2003
+++ BgChat-Ircd/src/balloc.c	Mon Mar 29 07:17:51 2004
@@ -1,15 +1,14 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  balloc.c: A block allocator.
  *
  * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center
  * Copyright (C) 1996-2002 Hybrid Development Team
- * Copyright (C) 2002 ircd-ratbox development team
  *
  *  File:   blalloc.c
  *  Owner:  Wohali (Joan Touzet)
  *  
- *  Modified 2001/11/29 for mmap() support by Aaron Sethman <androsyn@ratbox.org>
+ *  Modified 2001/11/29 for mmap() support by Aaron Sethman <androsyn@hybrid.org>
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -26,7 +25,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: balloc.c,v 7.63.2.3 2003/06/28 08:49:41 leeh Exp $
+ *  $Id: balloc.c,v 7.63.2.3 2004/02/09 21:18:55 HaKer4o Exp $
  */
 
 /* 
diff -uNrd ircd-ratbox-1.3-1/src/channel.c BgChat-Ircd/src/channel.c
--- ircd-ratbox-1.3-1/src/channel.c	Fri Sep  5 20:03:09 2003
+++ BgChat-Ircd/src/channel.c	Mon Mar 29 07:17:51 2004
@@ -1,10 +1,9 @@
 /*
- *  ircd-ratbox: A slightly useful ircd.
+ *  ircd-hybrid: A slightly useful ircd.
  *  channel.c: Controls channels.
  *
  * Copyright (C) 1990 Jarkko Oikarinen and University of Oulu, Co Center 
  * Copyright (C) 1996-2002 Hybrid Development Team 
- * Copyright (C) 2002 ircd-ratbox development team 
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
@@ -21,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: channel.c,v 7.381.2.8 2003/09/06 00:03:09 leeh Exp $
+ *  $Id: channel.c,v 7.381.2.8 2004/02/09 22:34:15 HaKer4o Exp $
  */
 
 #include "stdinc.h"
@@ -799,6 +798,26 @@
 	if(chptr->mode.limit && 
 	   dlink_list_length(&chptr->members) >= chptr->mode.limit)
 		return (ERR_CHANNELISFULL);
+
+
+	/* +A +O modes check */
+
+	if (chptr->mode.mode & MODE_ADMONLY)
+	{
+		if (!IsAdmin(source_p))
+		{
+			return (ERR_ADMINCHAN);
+		}
+	}
+
+	if (chptr->mode.mode & MODE_OPRONLY)
+	{
+		if (!IsOper(source_p))
+		{
+			return (ERR_OPERCHAN);
+		}
+	}
+
 
 	return 0;
 }
